; 
;   Copyright 1994-2003 Free Software Foundation, Inc.
;
;   This library is free software; you can redistribute it and/or
;   modify it under the terms of the GNU Lesser General Public
;   License as published by the Free Software Foundation; either
;   version 2.1 of the License, or (at your option) any later version.
;
;   This library is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;   Lesser General Public License for more details.
;
;   You should have received a copy of the GNU Lesser General Public
;   License along with this library; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
;   USA
;
;   You may contact the author at:
;
;   mailto::camille@bluegrass.net
;
;   or by snail mail at:
;
;   David Lindauer
;   850 Washburn Ave Apt 99
;   Louisville, KY 40222
;
%include "matherr.inc"

%ifdef __BUILDING_LSCRTL_DLL
[export ___nancompare]
%endif
[global ___nancompare]

SECTION _DATA CLASS=DATA USE32

SECTION _TEXT CLASS=CODE USE32

___nancompare:
    mov ecx,[esp + 28]
    mov eax,0
    call clearmath
    fld tword [esp+16] ; y
    fnclex
    fxam
    fnclex
    fstsw ax
    and ah,45h
    cmp ah,1
    jz retunordered1
	fld	tword [esp+4]  ; x
    fnclex
    fxam
    fnclex
    fstsw ax
    and ah,45h
    cmp ah,1
    jz retunordered2
    or ecx,ecx      ; unorder check?
    jz retfalse2
    fcompp
    fstsw ax
    test cl,1
    jnz  notequal
    sahf
    jz rettrue
notequal
    test cl,cl
    jns less
    sahf
    ja rettrue
    jmp retfalse    
less:
    sahf
    jb rettrue
retfalse:
    sub eax,eax
    ret
retfalse2:
    poptwo
    jmp retfalse
retunordered2:
    ffree st1
retunordered1:
    ffree st0
rettrue:
    mov eax,1
    ret
